// Spice_SOM_HowtoMakeData.cpp
// 

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <math.h>
#include <vector>
#include <omp.h>
struct SomDataFormat
{
   float **fTrainingSetIn;    //all of training sets
   char  (*strLabel)[255];    //label of the data
   int    nDataSets;          //number of data sets
   int    iDataLength;        //length of the data
};
 void FreeSomData(SomDataFormat *TrainingData)
{
      delete [] TrainingData->strLabel ;         // char[nDataSets][255];
      for (int i = 0; i < TrainingData->nDataSets; i++)
          delete TrainingData->fTrainingSetIn[i]; //float[iDataLength];
      delete [] TrainingData->fTrainingSetIn;     // float*[nDataSets];
      return;
};
void InitSomData(SomDataFormat *TrainingData, int nDataSets, int iDataLength)
{
   TrainingData->nDataSets        = nDataSets;
   TrainingData->iDataLength      = iDataLength;
   TrainingData->strLabel         = new char[nDataSets][255];
   TrainingData->fTrainingSetIn   = new float*[nDataSets];
   for (int i = 0; i < nDataSets; i++)
       TrainingData->fTrainingSetIn[i] = new float[iDataLength];
   return;
}

int CreateTrainingDataFromTxt(char *txtFilename, int nData, int iDataLength)
{
   SomDataFormat newData;
   InitSomData(&newData, nData, iDataLength); // initialize 
   FILE *f = fopen(txtFilename, "r");
   char tmp[255];
   for (int i = 0; i < iDataLength + 2; i++){
      fscanf(f, "%s", tmp);
   }
   for (int j = 0; j < nData; j++)
   {
      fscanf(f, "%s", tmp); // ID
      for (int i = 0; i < iDataLength; i++){
         fscanf(f, "%s", tmp);
         newData.fTrainingSetIn[j][i] = atof(tmp);
      }

      fscanf(f, "%s", tmp); // label
      sprintf(newData.strLabel[j], tmp); // assign label for the i-th dataset, please remember length of the label is 255
   }
   fclose(f);

   char fname[255];
   sprintf(fname, "%s_read.txt", txtFilename);
   f = fopen(fname, "w");
   for (int j = 0; j < nData; j++){
      for (int i = 0; i < iDataLength; i++){
         fprintf(f, "%f ", newData.fTrainingSetIn[j][i]);
      }
      fprintf(f, "%s \n", newData.strLabel[j]);
   }
   fclose(f);
   sprintf(fname, "%s.dat", txtFilename);

   // write data to binary file

   FILE *fout = fopen(fname, "wb");
   fwrite(&nData, sizeof(int), 1, fout);
   fwrite(&iDataLength, sizeof(int),  1, fout);
   for (int j = 0; j < nData; j++) 
   {
      fwrite(newData.fTrainingSetIn[j], sizeof(float), iDataLength, fout);
      fwrite(newData.strLabel[j], sizeof(char), 255, fout);
   };
  fclose(fout);

  FreeSomData(&newData);

  return 0;

}
int main()
{
   char txtFilename[] = "iris_for_som_150_data_4_inputs.txt";
   int nData = 150;
   int iDataLength = 4;
   CreateTrainingDataFromTxt(txtFilename, nData, iDataLength);
	return 0;
}

